define(['dojo/_base/lang','dojo/date/locale','dojo/date/stamp'],function(lang,locale,stamp){
    var SurveyRun = {
        create: function(){
            return { type:'SurveyRun' };
        },
        StartDate: {
            get: function(sr) {
                var d;
                if ( sr.startDate ) {
                    d = lang.isString(sr.startDate) ? stamp.fromISOString(sr.startDate) : sr.startDate;
                }
                return d;
            },
            set: function(sr,d) {
                if ( d ) {
                    sr.startDate = lang.isString(d) ? stamp.toISOString(d) : d;
                }
            }
        },
        EndDate: {
            get: function(sr) {
                var d;
                if ( sr.endDate ) {
                    d = lang.isString(sr.endDate) ? stamp.fromISOString(sr.endDate) : sr.endDate;
                }
                return d;
            },
            set: function(sr,d) {
                if ( d ) {
                    sr.endDate = lang.isString(d) ? stamp.toISOString(d) : d;
                }
            }
        },
        DisplayTitle: {
            get: function(sr) {
                var t = "Run of '"+sr.survey.title+"'";
                if ( sr.startDate ) {
                    t += " from "+locale.format(SurveyRun.StartDate.get(sr));
                }
                if ( sr.endDate ) {
                    t += " until "+locale.format(SurveyRun.EndDate.get(sr));
                }
                return t;
            }
        },
        Survey: {
            get: function(sr) {
                return sr.survey || null;
            },
            set: function(sr,s) {
                sr.survey = s;
                return sr;
            }
        }
    };
    return SurveyRun;
});
