define([
    "../../store",
    "../classes/Survey",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dojo/text!./templates/SurveySummary.html"
], function(store, Survey, _TemplatedMixin, _WidgetBase, declare, domAttr, template) {
    return declare([_WidgetBase,_TemplatedMixin],{
        templateString: template,
        survey: null,
        startup: function() {
            this.inherited(arguments);
            if ( this.survey ) {
                this._setValueAttr(this.survey);
            }
        },
        _setValueAttr: function(survey) {
            this.titleNode.innerHTML = Survey.DisplayTitle.get(survey);
            var id = store.getIdentity(survey);
            domAttr.set(this.titleNode, "href", id && ("#!/survey/"+id));
            this.descriptionNode.innerHTML = survey.description;
            this.questionsNode.innerHTML = (survey.questions || []).length;
        }
    });
});
